// hw_config.c
// : Ezhik
// : 12.09.2011
//    MCD Application Team (thx very much!)
//    
//   TE

#include "platform_config.h"

#include "stm32f10x_it.h"

#include "hw_config.h"

#ifdef USE_USB
#include "usb_lib.h"
#include "usb_pwr.h"
#endif

#include <stdio.h>

//  
ErrorStatus HSEStartUpStatus;

 
#ifdef USE_COM
static void InitCOM1();
static void InitCOM2();

static void COM1_RcvHandler(char c);
static void COM2_RcvHandler(char c);
#endif


// -------------------------------------------------
// COM

#ifdef USE_COM
void InitCOM(void)
{
	InitCOM1();
	InitCOM2();
}

void InitCOM1()
{
	#ifdef COM1

    NVIC_InitTypeDef NVIC_InitStructure;
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

	RCC_APB2PeriphClockCmd(COM1_GPIO_CLK | RCC_APB2Periph_AFIO, ENABLE);

	if(COM1_GPIO_REMAP != 0)
	{
		GPIO_PinRemapConfig(COM1_GPIO_REMAP, ENABLE);
	}

	switch(COM1_CLK_APB)
	{
		case 1:
			RCC_APB1PeriphClockCmd(COM1_CLK, ENABLE);
			break;
		case 2:
		default:
			RCC_APB2PeriphClockCmd(COM1_CLK, ENABLE);
			break;
	}
	

	// TX  Alternate Function Push-Pull
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Pin = COM1_TxPin;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(COM1_GPIO, &GPIO_InitStructure);

	// RX  Floating Input
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Pin = COM1_RxPin;
	GPIO_Init(COM1_GPIO, &GPIO_InitStructure);

	// 115200 , 8 , 1 , N ,  ,    
	USART_InitStructure.USART_BaudRate = 115200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(COM1, &USART_InitStructure);

	//  
	NVIC_InitStructure.NVIC_IRQChannel = COM1_IRQ;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
	//    
	USART_ITConfig(COM1, USART_IT_RXNE, ENABLE);

	
	USART_Cmd(COM1, ENABLE);

	#endif

}

void InitCOM2()
{
	#ifdef COM2

    NVIC_InitTypeDef NVIC_InitStructure;
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

	RCC_APB2PeriphClockCmd(COM2_GPIO_CLK | RCC_APB2Periph_AFIO, ENABLE);

	if(COM2_GPIO_REMAP != 0)
	{
		GPIO_PinRemapConfig(COM2_GPIO_REMAP, ENABLE);
	}

	switch(COM2_CLK_APB)
	{
		case 1:
			RCC_APB1PeriphClockCmd(COM2_CLK, ENABLE);
			break;
		case 2:
		default:
			RCC_APB2PeriphClockCmd(COM2_CLK, ENABLE);
			break;
	}
	

	// TX  Alternate Function Push-Pull
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Pin = COM2_TxPin;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(COM2_GPIO, &GPIO_InitStructure);

	// RX  Floating Input
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Pin = COM2_RxPin;
	GPIO_Init(COM2_GPIO, &GPIO_InitStructure);

	// 115200 , 8 , 1 , N ,  ,    
	USART_InitStructure.USART_BaudRate = 115200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(COM2, &USART_InitStructure);

	//  
	NVIC_InitStructure.NVIC_IRQChannel = COM2_IRQ;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
	//    
	USART_ITConfig(COM2, USART_IT_RXNE, ENABLE);

	USART_Cmd(COM2, ENABLE);

	#endif
}

//   USART,    -  
#if (defined COM1_USART1_USE_INTERRUPT_HANDLER) || (defined COM2_USART1_USE_INTERRUPT_HANDLER)
void USART1_IRQHandler()
{
	char c = USART_ReceiveData(USART1);
	#ifdef COM1_USART1_USE_INTERRUPT_HANDLER
			COM1_RcvHandler(c);
	#endif
	#ifdef COM2_USART1_USE_INTERRUPT_HANDLER
			COM2_RcvHandler(c);
	#endif
}
#endif

#if (defined COM1_USART2_USE_INTERRUPT_HANDLER) || (defined COM2_USART2_USE_INTERRUPT_HANDLER)
void USART2_IRQHandler()
{
	char c = USART_ReceiveData(USART2);
	#ifdef COM1_USART2_USE_INTERRUPT_HANDLER
			COM1_RcvHandler(c);
	#endif
	#ifdef COM2_USART2_USE_INTERRUPT_HANDLER
			COM2_RcvHandler(c);
	#endif
}
#endif

#if (defined COM1_USART3_USE_INTERRUPT_HANDLER) || (defined COM2_USART3_USE_INTERRUPT_HANDLER)
void USART3_IRQHandler()
{
	char c = USART_ReceiveData(USART3);
	#ifdef COM1_USART3_USE_INTERRUPT_HANDLER
			COM1_RcvHandler(c);
	#endif
	#ifdef COM2_USART3_USE_INTERRUPT_HANDLER
			COM2_RcvHandler(c);
	#endif
}
#endif
		 
//     COM1
void COM1_RcvHandler(char c)
{
	#ifdef COM1_AS_STDOUT
		printf("%c", c);
	#else
	// $COM - 
	#endif
}

//     COM2
void COM2_RcvHandler(char c)
{
	#ifdef COM2_AS_STDOUT
		printf("%c", c);
	#else
	// $COM - 
	#endif
}

//     COM
void COM_SendData(USART_TypeDef* USARTx, uint8_t *data, int length)
{
	int i;

	for(i=0; i < length;i++)
	{
		USART_SendData(USARTx, (uint8_t) data[i]);
	
		while (USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET)
		{}
	}
}

#else	// USE_COM
#define USART1_IRQHandler Dummy
#define USART2_IRQHandler Dummy
#define USART3_IRQHandler Dummy

void Dummy() {}

#endif	// USE_COM


// -------------------------------------------------
// LED

#ifdef USE_LEDS
//   
void Led_Config(void)
{
	//   led.c,       ,    
	Led_Init();
}
#endif

// -------------------------------------------------
// USB

#ifdef USE_USB
//   USB (48 )
void Set_USBClock(void)
{
#if defined(STM32F10X_CL)
  /* Select USBCLK source */
  RCC_OTGFSCLKConfig(RCC_OTGFSCLKSource_PLLVCO_Div3);

  /* Enable the USB clock */ 
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_OTG_FS, ENABLE) ;
#else
  /* Select USBCLK source */
  RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_1Div5);
  
  /* Enable the USB clock */
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USB, ENABLE);
#endif 
  
}

//  USB-
void USB_Interrupts_Config(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

#if defined(STM32F10X_CL) 
  NVIC_InitStructure.NVIC_IRQChannel = OTG_FS_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  
#else
  NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN1_RX0_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);

  NVIC_InitStructure.NVIC_IRQChannel = USB_HP_CAN1_TX_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
#endif /* STM32F10X_CL */
  
}


//  - USB-
void USB_Cable_Config (FunctionalState NewState)
{
#if defined(STM32F10X_CL) 
  if (NewState != DISABLE)
  {
    USB_DevConnect();
  }
  else
  {
    USB_DevDisconnect();
  }
  
#else 
#ifdef USB_DISCONNECT
  if (NewState != USB_DISCONNECT_LOG1)
  {
    GPIO_ResetBits(USB_DISCONNECT, USB_DISCONNECT_PIN);
  }
  else
  {
    GPIO_SetBits(USB_DISCONNECT, USB_DISCONNECT_PIN);
  }
#endif
#endif
}

//  ,    - USB
// RCC_APB2Periph_GPIO_DISCONNECT, USB_DISCONNECT, USB_DISCONNECT_PIN    platform_config.h
void USB_Disconnect_Config(void)
{
#ifdef USB_DISCONNECT
  GPIO_InitTypeDef GPIO_InitStructure;

  //   
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIO_DISCONNECT, ENABLE);


  //    Out Push-Pull
  GPIO_SetBits(USB_DISCONNECT, USB_DISCONNECT_PIN);
  GPIO_InitStructure.GPIO_Pin = USB_DISCONNECT_PIN;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(USB_DISCONNECT, &GPIO_InitStructure);

  //   - . 1.   USB.
  GPIO_SetBits(USB_DISCONNECT, USB_DISCONNECT_PIN);
#endif
}

#ifdef STM32F10X_CL
/*******************************************************************************
* Function Name  : USB_OTG_BSP_uDelay.
* Description    : provide delay.
* Input          : Delay in micro seconds.
* Output         : None.
* Return         : None.
*******************************************************************************/
void USB_OTG_BSP_uDelay (const uint32_t usec)
{
/*
  RCC_ClocksTypeDef  RCC_Clocks;  

  /* Configure HCLK clock as SysTick clock source 
  SysTick_CLKSourceConfig(SysTick_CLKSource_HCLK);
  
  RCC_GetClocksFreq(&RCC_Clocks);
  
  SysTick_Config(usec * (RCC_Clocks.HCLK_Frequency / 1000000));  
  
  SysTick->CTRL  &= ~SysTick_CTRL_TICKINT_Msk ;
  
  while (!(SysTick->CTRL & SysTick_CTRL_COUNTFLAG_Msk));
*/
	
	int i;
	for(i=0;i<SystemCoreClock / 1000000;i++);
	//     ,   .     systick 
}
#endif

//   .       .
void Enter_LowPowerMode(void)
{
  //     Suspended
  bDeviceState = SUSPENDED;
}

//     .   .
void Leave_LowPowerMode(void)
{
  DEVICE_INFO *pInfo = &Device_Info;

  //    
  if (pInfo->Current_Configuration != 0)
  {
    bDeviceState = CONFIGURED;
  }
  else
  {
    bDeviceState = ATTACHED;
  }

}

//    .
//  .     VID, PID  Windows-  STM
void Get_SerialNum(void)
{
  /* 
  uint32_t Device_Serial0, Device_Serial1, Device_Serial2;

  Device_Serial0 = *(__IO uint32_t*)(0x1FFFF7E8);
  Device_Serial1 = *(__IO uint32_t*)(0x1FFFF7EC);
  Device_Serial2 = *(__IO uint32_t*)(0x1FFFF7F0);

  if (Device_Serial0 != 0)
  {
    SomeDev_StringSerial[2] = (uint8_t)(Device_Serial0 & 0x000000FF);
    SomeDev_StringSerial[4] = (uint8_t)((Device_Serial0 & 0x0000FF00) >> 8);
    SomeDev_StringSerial[6] = (uint8_t)((Device_Serial0 & 0x00FF0000) >> 16);
    SomeDev_StringSerial[8] = (uint8_t)((Device_Serial0 & 0xFF000000) >> 24);

    SomeDev_StringSerial[10] = (uint8_t)(Device_Serial1 & 0x000000FF);
    SomeDev_StringSerial[12] = (uint8_t)((Device_Serial1 & 0x0000FF00) >> 8);
    SomeDev_StringSerial[14] = (uint8_t)((Device_Serial1 & 0x00FF0000) >> 16);
    SomeDev_StringSerial[16] = (uint8_t)((Device_Serial1 & 0xFF000000) >> 24);

    SomeDev_StringSerial[18] = (uint8_t)(Device_Serial2 & 0x000000FF);
    SomeDev_StringSerial[20] = (uint8_t)((Device_Serial2 & 0x0000FF00) >> 8);
    SomeDev_StringSerial[22] = (uint8_t)((Device_Serial2 & 0x00FF0000) >> 16);
    SomeDev_StringSerial[24] = (uint8_t)((Device_Serial2 & 0xFF000000) >> 24);
  }
  */
}

#endif // USE_USB


// ---------------------------------------------------------

//    
void RCC_Config(void)
{ 
  //  SYSCLK, HCLK, PCLK2  PCLK1 
  RCC_DeInit();
  RCC_HSEConfig(RCC_HSE_ON);
  HSEStartUpStatus = RCC_WaitForHSEStartUp();

  if (HSEStartUpStatus == SUCCESS)
  {
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
    FLASH_SetLatency(FLASH_Latency_2);
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 
    RCC_PCLK2Config(RCC_HCLK_Div1); 
    RCC_PCLK1Config(RCC_HCLK_Div2);

#ifdef STM32F10X_CL	//   105-107     25 ,       - 8 
    RCC_PREDIV2Config(RCC_PREDIV2_Div5);
    RCC_PLL2Config(RCC_PLL2Mul_8);
    RCC_PLL2Cmd(ENABLE);
    while (RCC_GetFlagStatus(RCC_FLAG_PLL2RDY) == RESET)
    {}
    RCC_PREDIV1Config(RCC_PREDIV1_Source_PLL2, RCC_PREDIV1_Div5);
    RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_9);
#else
    // PLLCLK = 8MHz * 9 = 72 MHz
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);
#endif

    RCC_PLLCmd(ENABLE);

    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    while(RCC_GetSYSCLKSource() != 0x08)
    {
    }
  }
  else
  {
  	//    HSE,     
	//     

    while (1)
    {
    }
  }
}			

//  
